

; ========================
;
;                Multiple Document Interface
;   
; ========================


    .586                                ; create 32 bit code
    .model flat, stdcall                ; 32 bit memory model
    option casemap :none                ; case sensitive
  
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\macros\macros.asm
    include \masm32\include\gdi32.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\Comctl32.inc
    include \masm32\include\comdlg32.inc
    include \masm32\include\shell32.inc
    include \masm32\include\oleaut32.inc
    include \masm32\include\msvcrt.inc

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\gdi32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\Comctl32.lib
    includelib \masm32\lib\comdlg32.lib
    includelib \masm32\lib\shell32.lib
    includelib \masm32\lib\oleaut32.lib
    includelib \masm32\lib\msvcrt.lib

    ; ======= Prototypes =======

    DefChildWindowProc     PROTO :DWORD, :DWORD, :DWORD, :DWORD
    WinMain                PROTO :DWORD, :DWORD, :DWORD, :DWORD
    FrameWindowProc        PROTO :DWORD, :DWORD, :DWORD, :DWORD


    .const
      ID_DEFCHILD    equ    101


    .data?

    .data

      hinstance               dd        0
      hwndframe               dd        0
      hwndclient              dd        0
      hAccel                  dd        0
      hwnddefchild            dd        0

      windowname              db   "WindowForge",0
      wclassname              db   "classforge",0
      defchildwin_classname   db   "def_child_class", 0
      menuname                db   "Filemenu",0
      pcommandline            dd        0

      temp                    dd        0
      temp1                   dd        0


      frame_wcl            WNDCLASSEX           { } 
      defchild_wcl         WNDCLASSEX           { }
      ccs               CLIENTCREATESTRUCT      { }       ; used in the client window creation
      defchild_mdics     MDICREATESTRUCT        { }       ; used in a MDIChild window creation - if using CreateWindowEx then the lparam of CREATESTRUCT contains a pointer to this structure
      defchild_cs          CREATESTRUCT         { }       ; 
      cs_struct           CREATESTRUCT          { }
       
; =============================================================================================


    .code

start:


    invoke GetModuleHandle, NULL
    mov hinstance, eax                  ; instance handle of this application.

    invoke GetCommandLine
    mov pcommandline, eax               ; fetch the command line address
    invoke WinMain, hinstance, NULL, NULL, SW_SHOWDEFAULT
    invoke ExitProcess, eax             ; close this application after the win is destroyed

  
WinMain proc hInstance:DWORD, hPrevInstance:DWORD, lpCmdLine:DWORD, nCmdShow:DWORD

      LOCAL msg                   :MSG

   mov ebx, hInstance             ; handle to the current instance of the application

; -------------------------------------------------------------------------------------------------------
;      fill up the  WNDCLASSEX  structure for the Frame Window
; -------------------------------------------------------------------------------------------------------

      mov frame_wcl.cbSize,     sizeof WNDCLASSEX
      mov frame_wcl.style,      CS_HREDRAW or CS_VREDRAW \
                        or      CS_BYTEALIGNWINDOW
      mov frame_wcl.lpfnWndProc,  offset FrameWindowProc
      mov frame_wcl.cbClsExtra,       0                   ; 0 = extra memory not used, 40bytes max
      mov frame_wcl.cbWndExtra,       0
      mov frame_wcl.hInstance,        ebx 
      invoke LoadIcon,NULL, IDI_ASTERISK
      mov frame_wcl.hIcon,            eax                 ; ALT+TAB icon etc
      invoke LoadCursor, NULL, IDC_ARROW            ; predefined cursor (could use LoadImage)
      mov frame_wcl.hCursor,          eax
      mov frame_wcl.hbrBackground,    COLOR_BTNFACE+1
      mov frame_wcl.lpszMenuName,     0
      mov frame_wcl.lpszClassName,    offset wclassname
      mov frame_wcl.hIconSm,          NULL                ; window's title bar icon etc


   invoke RegisterClassEx, addr frame_wcl                  ; register the frame class


; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
;   Fill up the WNDCLASSEX structure for the default child window
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

      mov defchild_wcl.cbSize,              sizeof WNDCLASSEX
      mov defchild_wcl.style,               CS_HREDRAW or CS_VREDRAW \
                                            or CS_BYTEALIGNWINDOW
      mov defchild_wcl.lpfnWndProc,         offset DefChildWindowProc
      mov defchild_wcl.cbClsExtra,          0                   ; 0 = extra memory not used, 40bytes max
      mov defchild_wcl.cbWndExtra,          32
      mov defchild_wcl.hInstance,           ebx 
      invoke LoadIcon, NULL, IDI_ASTERISK
      mov defchild_wcl.hIcon,               eax                 ; ALT+TAB icon etc
      invoke LoadCursor, NULL, IDC_ARROW                        ; predefined cursor (could use LoadImage)
      mov defchild_wcl.hCursor,             eax
      mov defchild_wcl.hbrBackground,       COLOR_BTNFACE+1
      mov defchild_wcl.lpszMenuName,        0                   ; NULL since a child widow can't have its own menu
      mov defchild_wcl.lpszClassName,       offset defchildwin_classname
      mov defchild_wcl.hIconSm,             NULL                ; window's title bar icon etc


   invoke RegisterClassEx, addr defchild_wcl                    ; register the default child window class
    

  ; -------------------------
  ;             Create the Frame Window
  ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  ;  
  ;   If an application processes WM_NCCREATE & returns FALSE, the
  ;   CreateWindowEx function will return a NULL handle.
  ; -------------------------

    invoke CreateWindowEx,
           WS_EX_OVERLAPPEDWINDOW,
           addr wclassname, 
           addr windowname,        
           WS_OVERLAPPEDWINDOW\
                 or WS_HSCROLL\   
                 or WS_VSCROLL,
           CW_USEDEFAULT, 
           CW_USEDEFAULT,
           CW_USEDEFAULT,
           CW_USEDEFAULT, 
           NULL,
           NULL,
           hInstance,                      
           NULL                             

    mov hwndframe, eax                                ; returns the handle to the new window created.

    invoke ShowWindow, hwndframe, SW_SHOWNORMAL
    invoke UpdateWindow, hwndframe                ; Updates the client area by sending a WM_PAINT


; --------------------------------
;    Create the client window
; --------------------------------

    mov ccs.idFirstChild, ID_DEFCHILD          ; 1st child id in CLIENTCREATESTRUCT member

    invoke CreateWindowEx,
           NULL,
           chr$("MDICLIENT",0),
           NULL,        
           WS_CHILD or WS_CLIPCHILDREN or MDIS_ALLCHILDSTYLES\
        or WS_HSCROLL or WS_VSCROLL,
           CW_USEDEFAULT, 
           CW_USEDEFAULT,
           CW_USEDEFAULT,
           CW_USEDEFAULT, 
           hwndframe,
           NULL,
           hinstance,                      
           addr temp                              

    mov hwndclient, eax

   ; checks if the client win creation succeeded

    cmp eax, 0
    jne @F
    fn MessageBox,0,"Client Window Creation Failed","Title",MB_OK
  @@:
    invoke ShowWindow, hwndclient, SW_SHOWNORMAL
   ; invoke UpdateWindow, hwndclient



  ; ----------------------------
  ;  Message Loop
  ; ----------------------------

    MessageLoop:                              ; checks return values from the GetMessage Function
      invoke GetMessage, addr msg, NULL, 0, 0 ; retrieves a msg & removes it from the que & places it in a MSG structure
                                          
      .if eax == SDWORD ptr -1                ; === check for an error ===
        push eax
        fn MessageBox, 0, "GetMessage Error", "Error", MB_OK
        pop eax
        invoke DestroyWindow, hwndframe
      .endif                              
                                          
      cmp eax, 0                               ; 0 = WM_QUIT message retrieved by GetMessage -> exit the Loop
        jz ExitMsgLoop                    

        invoke TranslateMDISysAccel, hwndclient, addr msg
        cmp eax, 0                        ; returns False if not an MDIAcclmsg, else sends them to the active MDI child window
        jne MessageLoop                   ; loop if not false
        invoke TranslateAccelerator, hwndframe, hAccel, addr msg
        cmp eax, 0
        jne MessageLoop                   ; loop back if true (msg was processed)
   
        invoke TranslateMessage, addr msg ; translates virtual-key messages into character messages. 
        invoke DispatchMessage,  addr msg ; else Dispatch the Message to the WndProc for the window
        jmp MessageLoop
    ExitMsgLoop:
      mov eax, msg.wParam                 ; return the value passed in the WM_QUIT message's wParam parameter.
      ret                                 

  WinMain endp

; ==================================
;   Frame Window Proc
; ==================================

    FrameWindowProc proc hWndframe:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

      .if uMsg == WM_CREATE

       add temp, 1
       fn MessageBox,0,str$(temp),"Count WM_CREATE msgs",MB_OK

       ; call create_windows        ; creates child windows
  
      .elseif uMsg == WM_COMMAND

      .elseif uMsg == WM_PAINT
      
        ; xor eax, eax
        ; ret


      .elseif uMsg == WM_ERASEBKGND

      .elseif uMsg == WM_SIZE

      .elseif uMsg == WM_MENUCHAR

      .elseif uMsg == WM_SETFOCUS

      .elseif uMsg == WM_DESTROY
         
          invoke PostQuitMessage, NULL                ; if the main window is being destroyed
          return 0                                    ; 0 = proc processed the msg


      .elseif uMsg == WM_CLOSE
          jmp @F
          fn MessageBox, NULL, "do you wanna quit", "Exit", MB_YESNO
          cmp eax, IDYES
          jne @F
           
      @@:
          invoke DestroyWindow, hWndframe                ; if IDYES -> quit
          return 0

      .endif

      default_processing:
      invoke DefFrameProc, hWndframe, hwndclient, uMsg, wParam, lParam   ; default processing
        
      ret

    FrameWindowProc endp



; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
;             Default MDI Child Window Procedure
; -------------------------------------------------------------------------------------------------------------------------



DefChildWindowProc proc HWnddefchild:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD



      default_processing:
      invoke DefMDIChildProc, hwnddefchild, uMsg, wParam, lParam   ; default processing
       
      ret

DefChildWindowProc endp

; creates child windows

create_windows: 

    invoke CreateWindowEx,
           WS_EX_MDICHILD,
           addr defchildwin_classname,
           chr$("mdi child window",0),        
           WS_CHILD or WS_HSCROLL or WS_VSCROLL or WS_MAXIMIZE,
           50, 
           CW_USEDEFAULT,
           200,
           200, 
           hwndclient,
           ID_DEFCHILD,
           hinstance,                      
           addr defchild_cs

   mov hwnddefchild, eax
   cmp eax, 0
   jne @F
   invoke GetLastError
   
   fn MessageBox,0,str$(eax),"Failed Error",MB_OK
   

   ret
 @@:  
 ;  fn MessageBox,0,addr hwnddefchild,"Child win handle",MB_OK
   invoke ShowWindow, hwnddefchild, SW_SHOWNORMAL



ret

end start
































































comment 
-----------------------------------------------------------------------------------------
                            Notes

    Extra Class & WindowMemory
    
  * If an application requires more than 40 bytes, it should allocate its own memory
    and store a pointer to the memory in the extra class memory.
    SetClassWord and SetClassLong, GetClassLong 
    SetWindowLong GetWindowLong
    
  * 

------------------------------------------------------------------------------------------ 








